#include <string>
#include <map>
#include <limits>
#include <assert.h>

#include "lib.h"

std::string code(std::string key, std::string line, int coef)
{
	std::string result;

	std::string::const_iterator off = key.begin();

	for (std::string::const_iterator it=line.begin(); it!=line.end(); ++it) {
		if (*it>='A' && *it<='Z') {
			result.push_back((*it-'A'+coef*((*off)-'A'+1)+'Z'-'A'+1)%('Z'-'A'+1)+'A');
			++off;
			if (off==key.end())
				off = key.begin();
		} else
			assert(false);
	}
	return result;
}

int get_weight(std::string line, const std::map<std::string, int> &freqs)
{
	int result = 0;

	char prev = 0;
	for (std::string::const_iterator it=line.begin(); it!=line.end(); ++it) {
		if (prev) {
			std::string key;
			key.push_back(prev);
			key.push_back(*it);
			if (freqs.find(key) != freqs.end())
				result+=freqs.find(key)->second;
		}
		prev = *it;
	}
	return result;
}

void get_pairs(std::string line, std::multimap<int, std::string> &pairs)
{
	std::map<std::string, int> tmp;

	get_pairs(line, tmp);
	
	pairs.clear();

	for (std::map<std::string,int>::const_iterator it=tmp.begin(); it!=tmp.end(); ++it) {
		pairs.insert(std::pair<int,std::string>(it->second, it->first));
	}
}


void get_pairs(std::string line, std::map<std::string, int> &pairs)
{
	pairs.clear();

	char prev = 0;
	for (std::string::const_iterator it=line.begin(); it!=line.end(); ++it) {
		if (prev) {
			std::string key;
			key.push_back(prev);
			key.push_back(*it);
			++pairs[key];
		}
		prev = *it;
	}
}


std::string decode(std::string key, std::string line)
{
	return code(key, line, -1);
}

std::string encode(std::string key, std::string line)
{
	return code(key, line, 1);
}
